/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file BaseDriverAttributes.h
    \brief Definition of BaseDriver Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:44 2013
*/
   

#ifndef BaseDriverAttributes_H
#define BaseDriverAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



namespace magics {

class XmlNode;



class BaseDriverAttributes 
{
public:
//  --  constructor
    BaseDriverAttributes();
    
//  --  destructor
    virtual ~BaseDriverAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const BaseDriverAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	string title_;
	string name_;
	bool firstnumber_;
	string fullname_;
	string legacyname_;
	int numberingwidth_;
	string separator_;
	string mgb_template_;
	bool debug_;
	int width_;
	int resolution_;
	bool filelist_;
	string filelist_name_;
	intarray frame_list_;

private:
  
	friend ostream& operator<<(ostream& s,const BaseDriverAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
