/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file BoundariesAttributes.h
    \brief Definition of Boundaries Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:42 2013
*/
   

#ifndef BoundariesAttributes_H
#define BoundariesAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Colour.h"

namespace magics {

class XmlNode;



class BoundariesAttributes 
{
public:
//  --  constructor
    BoundariesAttributes();
    
//  --  destructor
    virtual ~BoundariesAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const BoundariesAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	LineStyle style_;
	auto_ptr<Colour> colour_;
	int thickness_;
	bool disputed_;
	LineStyle disputed_style_;
	auto_ptr<Colour> disputed_colour_;
	int disputed_thickness_;
	bool admistrative_;
	stringarray administrative_list_;
	LineStyle administrative_style_;
	auto_ptr<Colour> administrative_colour_;
	int administrative_thickness_;

private:
  
	friend ostream& operator<<(ostream& s,const BoundariesAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
