/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file CoastlinesAttributes.h
    \brief Definition of Coastlines Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:42 2013
*/
   

#ifndef CoastlinesAttributes_H
#define CoastlinesAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "LabelPlotting.h"
#include "GridPlotting.h"
#include "CoastPlotting.h"

namespace magics {

class XmlNode;



class CoastlinesAttributes 
{
public:
//  --  constructor
    CoastlinesAttributes();
    
//  --  destructor
    virtual ~CoastlinesAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const CoastlinesAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	auto_ptr<NoCoastPlotting> coastlines_;
	auto_ptr<NoGridPlotting> grid_;
	auto_ptr<NoLabelPlotting> label_;

private:
  
	friend ostream& operator<<(ostream& s,const CoastlinesAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
