/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file ContourAttributes.h
    \brief Definition of Contour Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:43 2013
*/
   

#ifndef ContourAttributes_H
#define ContourAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "ValuePlotBase.h"
#include "ContourMethod.h"
#include "IsoPlot.h"
#include "HiLoBase.h"

namespace magics {

class XmlNode;



class ContourAttributes 
{
public:
//  --  constructor
    ContourAttributes();
    
//  --  destructor
    virtual ~ContourAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const ContourAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	bool legend_;
	auto_ptr<IsoPlot> contour_;
	auto_ptr<ContourMethod> method_;
	double floor_;
	double ceiling_;
	bool setting_;
	string library_path_;
	auto_ptr<HiLoBase> hilo_;
	auto_ptr<ValuePlotBase> grid_;

private:
  
	friend ostream& operator<<(ostream& s,const ContourAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
