/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file FortranSceneNodeAttributes.h
    \brief Definition of FortranSceneNode Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:43 2013
*/
   

#ifndef FortranSceneNodeAttributes_H
#define FortranSceneNodeAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Colour.h"
#include "PageID.h"

namespace magics {

class XmlNode;



class FortranSceneNodeAttributes 
{
public:
//  --  constructor
    FortranSceneNodeAttributes();
    
//  --  destructor
    virtual ~FortranSceneNodeAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const FortranSceneNodeAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	double x_;
	double y_;
	double width_;
	double height_;
	bool frame_;
	auto_ptr<Colour> frame_colour_;
	LineStyle frame_line_style_;
	int frame_thickness_;
	auto_ptr<NoPageID> page_id_;
	string plot_layout_;
	string plot_start_;
	string plot_direction_;

private:
  
	friend ostream& operator<<(ostream& s,const FortranSceneNodeAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
