/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file FortranViewNodeAttributes.h
    \brief Definition of FortranViewNode Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:47 2013
*/
   

#ifndef FortranViewNodeAttributes_H
#define FortranViewNodeAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "PreviewVisitor.h"
#include "Colour.h"
#include "MagnifierVisitor.h"
#include "Transformation.h"

namespace magics {

class XmlNode;



class FortranViewNodeAttributes 
{
public:
//  --  constructor
    FortranViewNodeAttributes();
    
//  --  destructor
    virtual ~FortranViewNodeAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const FortranViewNodeAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	string vertical_;
	string horizontal_;
	double top_;
	double bottom_;
	double left_;
	double bottom_internal_;
	double left_internal_;
	double right_;
	double width_;
	double height_;
	double height_internal_;
	double width_internal_;
	auto_ptr<Colour> background_;
	bool frame_;
	auto_ptr<Colour> frame_colour_;
	LineStyle frame_line_style_;
	int frame_thickness_;
	double vertical_axis_with_;
	double horizontal_axis_height_;
	string overlay_;
	auto_ptr<Transformation> transformation_;
	string json_;
	bool title_;
	auto_ptr<NoPreviewVisitor> preview_;
	auto_ptr<NoMagnifierVisitor> magnify_;

private:
  
	friend ostream& operator<<(ostream& s,const FortranViewNodeAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
