/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file GridPlottingAttributes.h
    \brief Definition of GridPlotting Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:42 2013
*/
   

#ifndef GridPlottingAttributes_H
#define GridPlottingAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Colour.h"

namespace magics {

class XmlNode;



class GridPlottingAttributes 
{
public:
//  --  constructor
    GridPlottingAttributes();
    
//  --  destructor
    virtual ~GridPlottingAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const GridPlottingAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	LineStyle style_;
	int thickness_;
	auto_ptr<Colour> colour_;

private:
  
	friend ostream& operator<<(ostream& s,const GridPlottingAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
