/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file HiLoTechniqueAttributes.h
    \brief Definition of HiLoTechnique Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:44 2013
*/
   

#ifndef HiLoTechniqueAttributes_H
#define HiLoTechniqueAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Colour.h"

namespace magics {

class XmlNode;



class HiLoTechniqueAttributes 
{
public:
//  --  constructor
    HiLoTechniqueAttributes();
    
//  --  destructor
    virtual ~HiLoTechniqueAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const HiLoTechniqueAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	double contour_hilo_height_;
	string contour_hilo_quality_;
	auto_ptr<Colour> hi_colour_;
	auto_ptr<Colour> lo_colour_;

private:
  
	friend ostream& operator<<(ostream& s,const HiLoTechniqueAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
