/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file IsoHighlightAttributes.h
    \brief Definition of IsoHighlight Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:44 2013
*/
   

#ifndef IsoHighlightAttributes_H
#define IsoHighlightAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Colour.h"

namespace magics {

class XmlNode;



class IsoHighlightAttributes 
{
public:
//  --  constructor
    IsoHighlightAttributes();
    
//  --  destructor
    virtual ~IsoHighlightAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const IsoHighlightAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	LineStyle style_;
	double reference_;
	auto_ptr<Colour> colour_;
	int thickness_;
	int frequency_;

private:
  
	friend ostream& operator<<(ostream& s,const IsoHighlightAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
