/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file IsoLabelAttributes.h
    \brief Definition of IsoLabel Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:43 2013
*/
   

#ifndef IsoLabelAttributes_H
#define IsoLabelAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



namespace magics {

class XmlNode;



class IsoLabelAttributes 
{
public:
//  --  constructor
    IsoLabelAttributes();
    
//  --  destructor
    virtual ~IsoLabelAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const IsoLabelAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	string type_;
	string text_;
	double height_;
	string format_;
	bool blanking_;
	string font_;
	string style_;
	string colour_;
	int frequency_;

private:
  
	friend ostream& operator<<(ostream& s,const IsoLabelAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
