/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file IsoPlotAttributes.h
    \brief Definition of IsoPlot Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:43 2013
*/
   

#ifndef IsoPlotAttributes_H
#define IsoPlotAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "IsoHighlight.h"
#include "IsoLabel.h"
#include "LevelSelection.h"
#include "IsoShading.h"
#include "Colour.h"

namespace magics {

class XmlNode;



class IsoPlotAttributes 
{
public:
//  --  constructor
    IsoPlotAttributes();
    
//  --  destructor
    virtual ~IsoPlotAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const IsoPlotAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	string legend_special_;
	double resolution_;
	string technique_;
	string legend_text_;
	LineStyle style_;
	int thickness_;
	auto_ptr<Colour> colour_;
	auto_ptr<NoIsoHighlight> highlight_;
	auto_ptr<LevelSelection> levelSelection_;
	auto_ptr<NoIsoLabel> label_;
	auto_ptr<NoIsoShading> shading_;
	bool legend_only_;

private:
  
	friend ostream& operator<<(ostream& s,const IsoPlotAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
