/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file IsoShadingAttributes.h
    \brief Definition of IsoShading Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:43 2013
*/
   

#ifndef IsoShadingAttributes_H
#define IsoShadingAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "ColourTechnique.h"
#include "ShadingTechnique.h"

namespace magics {

class XmlNode;



class IsoShadingAttributes 
{
public:
//  --  constructor
    IsoShadingAttributes();
    
//  --  destructor
    virtual ~IsoShadingAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const IsoShadingAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	auto_ptr<ShadingTechnique> technique_;
	double max_;
	double min_;
	auto_ptr<ColourTechnique> colourMethod_;

private:
  
	friend ostream& operator<<(ostream& s,const IsoShadingAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
