/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file KMLDriverAttributes.h
    \brief Definition of KMLDriver Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:44 2013
*/
   

#ifndef KMLDriverAttributes_H
#define KMLDriverAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



namespace magics {

class XmlNode;



class KMLDriverAttributes 
{
public:
//  --  constructor
    KMLDriverAttributes();
    
//  --  destructor
    virtual ~KMLDriverAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const KMLDriverAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	bool kmz_;
	string description_;
	string author_;
	string link_;
	double height_;
	double latitude_;
	double longitude_;
	int transparency_;
	int tilt_;
	int range_;
	bool coastlines_;

private:
  
	friend ostream& operator<<(ostream& s,const KMLDriverAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
