/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file MagnifierVisitorAttributes.h
    \brief Definition of MagnifierVisitor Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:47 2013
*/
   

#ifndef MagnifierVisitorAttributes_H
#define MagnifierVisitorAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Colour.h"

namespace magics {

class XmlNode;



class MagnifierVisitorAttributes 
{
public:
//  --  constructor
    MagnifierVisitorAttributes();
    
//  --  destructor
    virtual ~MagnifierVisitorAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const MagnifierVisitorAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	string symbol_name_;
	string hidden_symbol_name_;
	auto_ptr<Colour> symbol_colour_;
	auto_ptr<Colour> hidden_symbol_colour_;
	double symbol_height_;
	double hidden_symbol_height_;
	string text_font_name_;
	double text_font_size_;
	auto_ptr<Colour> text_font_colour_;
	string text_format_;

private:
  
	friend ostream& operator<<(ostream& s,const MagnifierVisitorAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
