/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file NetcdfInterpretorAttributes.h
    \brief Definition of NetcdfInterpretor Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:44 2013
*/
   

#ifndef NetcdfInterpretorAttributes_H
#define NetcdfInterpretorAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



namespace magics {

class XmlNode;



class NetcdfInterpretorAttributes 
{
public:
//  --  constructor
    NetcdfInterpretorAttributes();
    
//  --  destructor
    virtual ~NetcdfInterpretorAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const NetcdfInterpretorAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	string path_;
	stringarray dimension_;
	string field_;
	double scaling_;
	double offset_;
	string missing_attribute_;
	string reference_;
	double suppress_below_;
	double suppress_above_;

private:
  
	friend ostream& operator<<(ostream& s,const NetcdfInterpretorAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
