/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file PageIDAttributes.h
    \brief Definition of PageID Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:46 2013
*/
   

#ifndef PageIDAttributes_H
#define PageIDAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "LogoPlotting.h"
#include "Colour.h"

namespace magics {

class XmlNode;



class PageIDAttributes 
{
public:
//  --  constructor
    PageIDAttributes();
    
//  --  destructor
    virtual ~PageIDAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const PageIDAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	double height_;
	auto_ptr<Colour> colour_;
	bool magics_;
	string user_text_;
	bool system_;
	bool date_;
	bool errors_;
	bool text_;
	auto_ptr<NoLogoPlotting> logo_;
	string font_;
	string font_style_;

private:
  
	friend ostream& operator<<(ostream& s,const PageIDAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
