/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file PolyShadingTechniqueAttributes.cc
    \brief Implementation of PolyShadingTechnique Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!
   
    Generated: Wed Dec 18 18:16:43 2013
*/    

#include "PolyShadingTechniqueAttributes.h"
#include "MagicsParameter.h"
#include "Factory.h"
#include "MagTranslator.h"
#include "XmlNode.h"
#include "ParameterSettings.h"


using namespace magics;


PolyShadingTechniqueAttributes::PolyShadingTechniqueAttributes():
	method_(MagTranslator<string, PolyShadingMethod>().magics("contour_shade_method"))
{
} 



PolyShadingTechniqueAttributes::~PolyShadingTechniqueAttributes()
{
}

    
void PolyShadingTechniqueAttributes::set(const std::map<string, string>& params)
{
	vector<string> prefix(5);
	prefix[0] = "contour_shade";
	prefix[1] = "contour_shade";
	prefix[2] = "contour_shade";
	prefix[3] = "contour";
	prefix[4] = "contour";

	setMember(prefix, "contour_shade_method", method_, params);
}

void PolyShadingTechniqueAttributes::copy(const PolyShadingTechniqueAttributes& other)
{
	method_ = auto_ptr<PolyShadingMethod>(other.method_->clone());
} 


bool PolyShadingTechniqueAttributes::accept(const string& node)
{	
	if ( magCompare(node, "polygon")  )
		return true;

	if ( acceptNode(node, method_) )
		return true;
	return false;
}

void PolyShadingTechniqueAttributes::set(const XmlNode& node)
{
	if ( this->accept(node.name()) == false ) 
		return;

	if ( magCompare(node.name(), "polygon") )
		set(node.attributes());
	else {
		setMember(node.name(), method_, node);
	}
	for (XmlNode::ElementIterator elt = node.firstElement(); elt != node.lastElement(); ++elt) {
		setMember((*elt)->name(), method_, *(*elt)); 
	}
}

void PolyShadingTechniqueAttributes::print(ostream& out)  const
{
	out << "PolyShadingTechniqueAttributes[";
	out << "method = " << *method_;
	out << "]" << "\n";
}


void PolyShadingTechniqueAttributes::toxml(ostream& out)  const
{
     out <<  "\"polygon\"";
	 out << ", \"contour_shade_method\":";
	 method_->toxml(out);
}
static MagicsParameter<string> contour_shade_method("contour_shade_method", "dot", "");
#include "PolyShadingMethod.h"
#include "DotPolyShadingMethod.h"
#include "HatchPolyShadingMethod.h"
static SimpleObjectMaker<PolyShadingMethod, PolyShadingMethod> area_fill_PolyShadingMethod("area_fill");
static SimpleObjectMaker<DotPolyShadingMethod, PolyShadingMethod> dot_DotPolyShadingMethod("dot");
static SimpleObjectMaker<HatchPolyShadingMethod, PolyShadingMethod> hatch_HatchPolyShadingMethod("hatch");
