/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file XmlRootNodeAttributes.h
    \brief Definition of XmlRootNode Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:46 2013
*/
   

#ifndef XmlRootNodeAttributes_H
#define XmlRootNodeAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Colour.h"

namespace magics {

class XmlNode;



class XmlRootNodeAttributes 
{
public:
//  --  constructor
    XmlRootNodeAttributes();
    
//  --  destructor
    virtual ~XmlRootNodeAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const XmlRootNodeAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	string format_;
	string orientation_;
	double width_;
	double height_;
	bool border_;
	auto_ptr<Colour> border_colour_;
	LineStyle border_style_;
	int border_thickness_;
	string application_;

private:
  
	friend ostream& operator<<(ostream& s,const XmlRootNodeAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
