/*******************************  LICENSE  *******************************



 *******************************  LICENSE  *******************************/

/*! \file XmlViewNodeAttributes.h
    \brief Definition of XmlViewNode Attributes class.
    \author Meteorological Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Wed Dec 18 18:16:43 2013
*/
   

#ifndef XmlViewNodeAttributes_H
#define XmlViewNodeAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Transformation.h"

namespace magics {

class XmlNode;



class XmlViewNodeAttributes 
{
public:
//  --  constructor
    XmlViewNodeAttributes();
    
//  --  destructor
    virtual ~XmlViewNodeAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const XmlViewNodeAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

	

public:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream& out) const;
	//  --  members:
	string tag_;
	string fitted_;
	auto_ptr<Transformation> transformation_;

private:
  
	friend ostream& operator<<(ostream& s,const XmlViewNodeAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
